﻿using System;
using System.Collections.ObjectModel;
using System.Reflection;
using Com.Syncfusion.Charts;

namespace ChartGettingStarted.Droid
{
    public class CustomLineSeries : LineSeries
    {
        protected override void CreateSegments()
        {
            base.CreateSegments();

            foreach (var segment in this.Segments)
            {
                PropertyInfo emptyInfo = typeof(ChartSegment).GetProperty("Empty", BindingFlags.NonPublic | BindingFlags.Instance);
                bool isEmpty = (bool)emptyInfo.GetValue(segment, null);
                if (isEmpty == true)
                {
                    isEmpty = !isEmpty;
                    emptyInfo.SetValue(segment, isEmpty);
                    HandleEmpltyPoints(segment as LineSegment);
                }
            }
        }

        void HandleEmpltyPoints(LineSegment segment)
        {
            PropertyInfo y1Info = typeof(LineSegment).GetProperty("Y1Pos", BindingFlags.NonPublic | BindingFlags.Instance);
            double y1 = (double)y1Info.GetValue(segment, null);

            PropertyInfo y2Info = typeof(LineSegment).GetProperty("Y2Pos", BindingFlags.NonPublic | BindingFlags.Instance);
            double y2 = (double)y2Info.GetValue(segment, null);

            PropertyInfo x1Info = typeof(LineSegment).GetProperty("X1Pos", BindingFlags.NonPublic | BindingFlags.Instance);
            double x1 = (double)x1Info.GetValue(segment, null);

            PropertyInfo x2Info = typeof(LineSegment).GetProperty("X2Pos", BindingFlags.NonPublic | BindingFlags.Instance);
            double x2 = (double)x2Info.GetValue(segment, null);

            double y = double.NaN;

            var data = (this.ItemsSource as ObservableCollection<Person>);
            int i = -1;
            if (double.IsNaN(y1))
                i = (int)x1;
            else i = (int)x2;

            if (double.IsNaN(data[i].Height))
            {
                if (i == 0)
                {
                    y = data[i + 1].Height / 2;
                }
                else if (i == data.Count - 1)
                {
                    y = data[i - 1].Height / 2;
                }
                else
                {
                    y = (data[i - 1].Height + data[i + 1].Height) / 2;
                }
            }
            if (double.IsNaN(y1))
                y1 = y;
            if (double.IsNaN(y2))
                y2 = y;

            y1Info.SetValue(segment, y1);
            y2Info.SetValue(segment, y2);

            MethodInfo setDataInfo = typeof(LineSegment).GetMethod("SetData", BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.DeclaredOnly);
            var values = new[] { x1, y1, x2, y2 };

            setDataInfo.Invoke(segment, new object[] { values });
        }
    }
}
