﻿using System;

using Android.App;
using Android.Content.PM;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Xamarin.Forms;
using Com.Syncfusion.Charts;
using System.Reflection;
using Forms = Syncfusion.SfChart.XForms;
using Syncfusion.SfChart.XForms.Droid;

namespace ChartGettingStarted.Droid
{
    [Activity(Label = "ChartGettingStarted", Icon = "@drawable/icon", Theme = "@style/MainTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation)]
    public class MainActivity : global::Xamarin.Forms.Platform.Android.FormsAppCompatActivity
    {
        protected override void OnCreate(Bundle bundle)
        {
            TabLayoutResource = Resource.Layout.Tabbar;
            ToolbarResource = Resource.Layout.Toolbar;

            base.OnCreate(bundle);
           
            global::Xamarin.Forms.Forms.Init(this, bundle);

            Xamarin.Forms.Forms.ViewInitialized += Forms_ViewInitialized;

            LoadApplication(new App());
        }

        private void Forms_ViewInitialized(object sender, ViewInitializedEventArgs e)
        {
            if (e.NativeView is SfChart)
            {
                var formsChart = e.View as Forms.SfChart;
                var nativeChart = (SfChart)e.NativeView as SfChart;

                for (int i = 0; i < nativeChart.Series.Count;i++)
                {
                    if(nativeChart.Series[i] is LineSeries)
                    {
                        nativeChart.Series.RemoveAt(i);
                        CustomLineSeries lineSeries = new CustomLineSeries();
                        SfChartRenderer.SetNativeObject(typeof(Forms.LineSeries), formsChart.Series[i], lineSeries);
                        nativeChart.Series.Insert(i,lineSeries);

                        var properties = SfChartRenderer.GetPropertiesChanged(typeof(Forms.LineSeries), formsChart.Series[i]);

                        foreach (string propName in properties)
                        {
                            ChartSeriesMapping.OnLineSeriesPropertiesChanged(propName, (Forms.LineSeries)formsChart.Series[i], lineSeries as LineSeries);
                        }

                        PropertyInfo formsSeriesInfo = typeof(ChartSeries).GetProperty("FormsSeries", BindingFlags.NonPublic | BindingFlags.Instance);
                        Forms.ChartSeries formsSeries = (Forms.ChartSeries)formsSeriesInfo.GetValue(lineSeries, null);
                        formsSeries = formsChart.Series[i];
                        formsSeriesInfo.SetValue(lineSeries, formsSeries);
                    }
                }
            }
        }
    }
}

