﻿using System;
using System.Collections.Generic;
using System.Linq;

using Foundation;
using UIKit;
using Syncfusion.SfChart.XForms.iOS.Renderers;
using Syncfusion.SfChart.iOS;
using Forms = Syncfusion.SfChart.XForms;
using Xamarin.Forms;
using Syncfusion.SfChart.XForms.iOS;
using System.Reflection;

namespace ChartGettingStarted.iOS
{
    // The UIApplicationDelegate for the application. This class is responsible for launching the 
    // User Interface of the application, as well as listening (and optionally responding) to 
    // application events from iOS.
    [Register("AppDelegate")]
    public partial class AppDelegate : global::Xamarin.Forms.Platform.iOS.FormsApplicationDelegate
    {
        //
        // This method is invoked when the application has loaded and is ready to run. In this 
        // method you should instantiate the window, load the UI into it and then make the window
        // visible.
        //
        // You have 17 seconds to return from this method, or iOS will terminate your application.
        //
        public override bool FinishedLaunching(UIApplication app, NSDictionary options)
        {
            global::Xamarin.Forms.Forms.Init();

            new SfChartRenderer();

             Xamarin.Forms.Forms.ViewInitialized += Forms_ViewInitialized;
            LoadApplication(new App());

            return base.FinishedLaunching(app, options);
        }

        private void Forms_ViewInitialized(object sender, ViewInitializedEventArgs e)
        {
			if (e.NativeView is SFChart)
			{
				var formsChart = e.View as Forms.SfChart;
				var nativeChart = (SFChart)e.NativeView as SFChart;

				for (int i = 0; i < nativeChart.Series.Count; i++)
				{
					if (nativeChart.Series[i] is SFLineSeries)
					{
						nativeChart.Series.RemoveAt(i);
						CustomLineSeries lineSeries = new CustomLineSeries();
						SfChartRenderer.SetNativeObject(typeof(Forms.LineSeries), formsChart.Series[i], lineSeries);
						nativeChart.Series.Insert(i, lineSeries);

						var properties = SfChartRenderer.GetPropertiesChanged(typeof(Forms.LineSeries), formsChart.Series[i]);

						foreach (string propName in properties)
						{
                            ChartSeriesMapping.OnLineSeriesPropertiesChanged(propName, (Forms.LineSeries)formsChart.Series[i], lineSeries as SFLineSeries);
						}

                        PropertyInfo formsSeriesInfo = typeof(SFSeries).GetProperty("FormsSeries", BindingFlags.NonPublic | BindingFlags.Instance);
						Forms.ChartSeries formsSeries = (Forms.ChartSeries)formsSeriesInfo.GetValue(lineSeries, null);
						formsSeries = formsChart.Series[i];
						formsSeriesInfo.SetValue(lineSeries, formsSeries);
					}
				}
			}
        }
    }
}
